// ---------------------------------------------------------------------------
//	class SoundBuffer 
//	Copyright (C) cisc 1999.
// ---------------------------------------------------------------------------
//	$Id: soundbuf.h,v 1.1 1999/06/27 14:45:04 cisc Exp $

#ifndef common_soundbuf_h
#define common_soundbuf_h

#include "types.h"
#include "critsect.h"

// ---------------------------------------------------------------------------
//	SoundBuffer
//
class SoundBuffer
{
public:
	typedef int16 Sample;

public:
	SoundBuffer();
	~SoundBuffer();

	bool Init(int nch, int bufsize);	// bufsize ̓TvP
	void Cleanup();

	void Put(int sample);				// obt@ɍő sample f[^ǉ
	void Get(Sample* ptr, int sample);	// obt@ sample ̃f[^𓾂
	bool IsEmpty();

	virtual void Mix(Sample* buffer, int sample) = 0;	// sample ̃f[^

private:
	void PutMain(int sample);
	
	Sample* buffer;
	CriticalSection cs;
	
	int buffersize;						// obt@̃TCY (in samples)
	int read;							// Ǎʒu (in samples)
	int write;							// ݈ʒu (in samples)
	int ch;								// `l(1sample = ch*Sample)
};

#endif // common_soundbuf_h
