// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator
//	Copyright (C) cisc 1999.
// ---------------------------------------------------------------------------
//	waveOut based driver
// ---------------------------------------------------------------------------
//	$Id: soundwo.h,v 1.2 1999/07/04 08:50:00 cisc Exp $

#if !defined(win32_soundwo_h)
#define win32_soundwo_h

#include "sounddrv.h"
#include "critsect.h"

// ---------------------------------------------------------------------------

namespace WinSoundDriver
{

class DriverWO : public Driver
{
public:
	DriverWO();
	~DriverWO();

	bool Init(SoundBuffer* sb, HWND hwnd, uint rate, uint ch, uint buflen);
	bool Cleanup();

private:
	bool SendBlock();
	void BlockDone(WAVEHDR*);
	static uint __stdcall ThreadEntry(LPVOID arg);

	HWAVEOUT hwo;
	HANDLE hthread;
	uint idthread;
	CriticalSection cs;
	int numblocks;
	bool dontmix;
};

}

#endif // win32_soundwo_h
